#define NUM2PTR(x) ((SCM *) (SCM_UNPACK(x) & ~2))
{
  //C trampolines
  int ret; SCM *spp;
  const SCM *vec;
  SCM (*subr)();
  
 vm_c_call:
  vec  = SCM_I_VECTOR_ELTS(SCM_CDR(program));
  spp  =  sp;
  subr = (subr_type) NUM2PTR(vec[0]);
  ret  = subr(&spp,nargs,vec + 1);
  sp   = spp;
  if(ret<0) NEXT; //TODO fix this

  nargs   = ret;  
  program = sp[-nargs];
  
  if(SCM_CONSP(program) && scm_is_eq(SCM_CAR(program),c_closure_tag))
    goto vm_c_call;
  
  goto vm_call;

 vm_c_tail_call:
  vec = SCM_I_VECTOR_ELTS(SCM_CDR(program));
  subr    = (subr_type) NUM2PTR(vec[0]);
  spp = sp;
  ret = subr(&spp, nargs, vec + 1);
  sp = spp;
  if(ret<0) NEXT; //TODO fix this
  nargs = ret;

  program = sp[-nargs];
  
  if(SCM_CONSP(program) && scm_is_eq(SCM_CAR(program),c_closure_tag))
    goto vm_c_tail_call;

  goto vm_tail_call;
}
